﻿using Microsoft.XLANGs.BaseTypes;
using Microsoft.XLANGs.Core;
using System;
using System.Collections;

namespace BizTalkLive.ContextPropertyAccessor
{
    public class ContextAccessor
    {
        public static Hashtable GetContext(XLANGMessage message)
        {
            try
            {
                foreach (Segment segment in Service.RootService._segments)
                {
                    IDictionary fields =
                        Context.FindFields(
                          typeof(XLANGMessage)
                        , segment.ExceptionContext);

                    foreach (DictionaryEntry field in fields)
                    {
                        XMessage msg = (field.Value as XMessage);
                        if (msg == null)
                            continue;

                        if (String.Compare(msg.Name, message.Name) != 0)
                            continue;


                        return msg.GetContextProperties();
                    }
                }
            }
            catch (Exception ex)
            {
                // do not provoke failure
                throw ex;
            }

            return new Hashtable();
        }

        public static string GetContextProperty(XLANGMessage message, string PropertyName, string PropertyNamespace)
        {
            string Property = "False";
            try
            {

                Microsoft.XLANGs.BaseTypes.XmlQName qname = new XmlQName(PropertyName, PropertyNamespace);
                foreach (Segment segment in Service.RootService._segments)
                {
                    IDictionary fields =
                        Context.FindFields(
                          typeof(XLANGMessage)
                        , segment.ExceptionContext);

                    foreach (DictionaryEntry field in fields)
                    {
                        XMessage msg = (field.Value as XMessage);
                        if (msg == null)
                            continue;

                        if (String.Compare(msg.Name, message.Name) != 0)
                            continue;

                        if (msg.GetContextProperties().ContainsKey(qname))
                        {
                            // get the property from GetContextProperties 
                            Property = msg.GetContextProperties()[qname].ToString();
                        }
                        else if (msg.GetContentProperties().ContainsKey(qname))
                        {
                            // get the property from GetContentProperties 
                            Property = msg.GetContentProperties()[qname].ToString();
                        }


                        return Property;

                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
                // do not provoke failure
                // probably best to add some logging here
            }

            return Property;
        }
    }
}